//multiplying two matrices over DNA Rings or matrix with its transpose for hadamard matrices
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class Solution 
{
	//multiplication
	public static int[][] a =
		{
		{ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{ 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},
		{ 0,2,0,2,8,10,8,10,0,2,0,2,8,10,8,10},
		{ 0,3,2,1,12,15,14,13,8,11,10,9,4,7,6,5},
		{ 0,4,8,12,10,14,2,6,0,4,8,12,10,14,2,6},
		{ 0,5,10,15,14,3,4,9,8,13,2,5,6,11,12,1},
		{ 0,6,8,14,2,4,10,12,0,6,8,14,8,7,10,12},
		{ 0,7,10,13,6,9,12,3,8,15,2,5,6,1,4,11},
		{ 0,8,0,8,0,8,0,8,0,8,0,8,0,8,0,8},
		{ 0,9,2,11,4,13,6,15,8,1,10,3,12,5,14,7},
		{ 0,10,0,10,8,2,8,2,0,10,0,10,8,2,8,2},
		{ 0,11,2,9,12,5,14,5,8,3,10,1,4,15,6,13},
		{ 0,12,8,4,10,6,8,6,0,12,8,4,10,6,2,14},
		{ 0,13,10,7,14,11,7,1,8,5,2,15,6,3,12,9},
		{ 0,14,8,6,2,12,10,4,0,14,8,6,2,12,10,4},
		{ 0,15,10,5,6,1,12,11,8,7,2,13,14,9,4,3}
		};

	//addition
	public static int[][] b =
		{
		{ 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15},
		{ 1,2,3,0,5,6,7,4,9,10,11,8,13,14,15,12},
		{ 2,3,0,1,6,7,4,5,10,11,8,9,14,15,12,13},
		{ 3,0,1,2,7,4,5,6,11,8,9,10,15,12,13,14},
		{ 4,5,6,7,8,9,10,11,12,13,14,15,0,1,2,3},
		{ 5,6,7,4,9,10,11,8,13,14,15,12,1,2,3,0},
		{ 6,7,4,5,10,11,8,9,14,15,12,13,2,3,0,1},
		{ 7,4,5,6,11,8,9,10,15,12,13,14,3,0,1,2},
		{ 8,9,10,11,12,13,14,15,0,1,2,3,4,5,6,7},
		{ 9,10,11,8,13,14,15,12,1,2,3,0,5,6,7,4},
		{ 10,11,8,9,14,15,12,13,2,3,0,1,6,7,4,5},
		{ 11,8,9,10,15,12,13,14,3,0,1,2,7,4,5,6},
		{ 12,13,14,15,0,1,2,3,4,5,6,7,8,9,10,11},
		{ 13,14,15,12,1,2,3,0,5,6,7,4,9,10,11,8},
		{ 14,15,12,13,2,3,0,1,6,7,4,5,10,11,8,9},
		{ 15,12,13,14,3,0,1,2,7,4,5,6,11,8,9,10}
		};
	public static void main(String args[]) throws Exception
	{
		BufferedReader rd = new BufferedReader(new InputStreamReader(System.in));
		/* System.out.println("Enter total number of elements in a row  :");
			int m = Integer.parseInt(rd.readLine());
			System.out.println("Enter total number of row  :");
			int n = Integer.parseInt(rd.readLine());
		*/
		PrintWriter pw = new PrintWriter(new File("hadamard.doc"));
		int m =3;
		int[][] c = {
				{7,8,10},
				{8,13,8},
				{10,8,5}
		};
		
		System.out.println("Original matrix: ");
		pw.println("Original matrix: ");
		for (int e = 0 ; e < m ; e++ )
		{
			for (int d = 0 ; d < m ; d++ ) 
			{
				pw.print(mapping(c[e][d]) + "\t");
				System.out.print(mapping(c[e][d]) + "\t");
			}
			System.out.println();
			pw.println();
		}
		
		System.out.println("Transpose of a matrix: ");
		pw.println("Transpose of a matrix: ");
		//transpose of a matrix
		int transpose[][] = new int[m][m];
		for (int e = 0 ; e < m ; e++ )
		{
			for (int d = 0 ; d < m ; d++ ) 
			{
				transpose[d][e] =c[e][d];
			}
		}

		//printing the transpose
		for (int e = 0 ; e < m ; e++ )
		{
			for (int d = 0 ; d < m ; d++ ) 
			{
				pw.print(mapping(transpose[e][d]) + "\t");
				System.out.print(mapping(transpose[e][d]) + "\t");
			}
			System.out.println();
			pw.println();
		}

		int sum=0,sum1=0;
		int[][] multiply = new int[m][m];
		//product of two matrices
		for (int e = 0 ; e < m ; e++ )
		{
			for (int d = 0 ; d < m ; d++ )
			{   
				for (int k = 0 ; k < m ; k++ )
				{
					sum1 = product(c[e][k],transpose[k][d]);
					sum = add(sum,sum1);
				}

				multiply[e][d] = sum;
				sum = 0;
				sum1=0;
			}
		}

		System.out.println("The product is : ");
		pw.println("The produxt is : ");
		for (int e = 0 ; e < m ; e++ )
		{
			for (int d = 0 ; d < m ; d++ )
			{
				System.out.print(mapping(multiply[e][d]) + "\t");
				pw.print(mapping(multiply[e][d]) + "\t");
			}
			System.out.print("\n");
			pw.println();
		}
		pw.close();
	}

	public static String mapping(int a)
	{
		String abc=null;
		if(a==0)
			abc= "    0    ";
		else if(a==1)
			abc=("    1    ");
		else if(a==2)
			abc=("    2    ");
		else if(a==3)
			abc=("    3    ");
		else if(a==4)
			abc=("    w    ");
		else if(a==5)
			abc=("   w+1   ");
		else if(a==6)
			abc=("   w+2   ");
		else if(a==7)
			abc=("   w+3   ");
		else if(a==8)
			abc=("    2w   ");
		else if(a==9)
			abc=("   2w+1  ");
		else if(a==10)
			abc=("   2w+2  ");
		else if(a==11)
			abc=("   2w+3  ");
		else if(a==12)
			abc=("    3w   ");
		else if(a==13)
			abc=("   3w+1  ");
		else if(a==14)
			abc=("   3w+2  ");
		else if(a==15)
			abc=("   3w+3  ");
		return abc;
	}

	public static int product(int c,int d)
	{
		return a[c][d];
	}
	public static int add(int c,int d)
	{
		return b[c][d];
	}

}
